From 6287b69f931a44c89c20208c5b41f79117d258f2 Mon Sep 17 00:00:00 2001
From: Tomas Vondra <tomas.vondra@postgresql.org>
Date: Wed, 20 Jul 2022 11:09:46 +0200
Subject: [PATCH 1/4] Add regression tests for (Var op Var)

A number of queries to test estimation of Var op Var clauses. The number
of new tests is likely an overkill, intended to showcase effects of
parts of this patch series.
---
 src/test/regress/expected/stats_ext.out | 2354 +++++++++++++++++++++--
 src/test/regress/sql/stats_ext.sql      |  650 +++++++
 2 files changed, 2847 insertions(+), 157 deletions(-)

diff --git a/src/test/regress/expected/stats_ext.out b/src/test/regress/expected/stats_ext.out
index 042316aeed8..009c7cfd848 100644
--- a/src/test/regress/expected/stats_ext.out
+++ b/src/test/regress/expected/stats_ext.out
@@ -1988,6 +1988,78 @@ SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists WHERE a = 1 OR b = '
        343 |    200
 (1 row)
 
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists WHERE a = a');
+ estimated | actual 
+-----------+--------
+      5000 |   5000
+(1 row)
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists WHERE a != a');
+ estimated | actual 
+-----------+--------
+      4975 |      0
+(1 row)
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists WHERE a <= a');
+ estimated | actual 
+-----------+--------
+      1667 |   5000
+(1 row)
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists WHERE a < a');
+ estimated | actual 
+-----------+--------
+      1667 |      0
+(1 row)
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists WHERE a > a');
+ estimated | actual 
+-----------+--------
+      1667 |      0
+(1 row)
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists WHERE a >= a');
+ estimated | actual 
+-----------+--------
+      1667 |   5000
+(1 row)
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists WHERE a = c');
+ estimated | actual 
+-----------+--------
+        25 |   1250
+(1 row)
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists WHERE a != c');
+ estimated | actual 
+-----------+--------
+      4975 |   3750
+(1 row)
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists WHERE a > c');
+ estimated | actual 
+-----------+--------
+      1667 |   3750
+(1 row)
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists WHERE a >= c');
+ estimated | actual 
+-----------+--------
+      1667 |   5000
+(1 row)
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists WHERE a < c');
+ estimated | actual 
+-----------+--------
+      1667 |      0
+(1 row)
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists WHERE a <= c');
+ estimated | actual 
+-----------+--------
+      1667 |   1250
+(1 row)
+
 SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists WHERE a IN (1, 2, 51, 52) AND b IN ( ''1'', ''2'')');
  estimated | actual 
 -----------+--------
@@ -2135,6 +2207,78 @@ SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists WHERE a = 1 OR b = '
        200 |    200
 (1 row)
 
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists WHERE a = a');
+ estimated | actual 
+-----------+--------
+      5000 |   5000
+(1 row)
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists WHERE a != a');
+ estimated | actual 
+-----------+--------
+      4975 |      0
+(1 row)
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists WHERE a <= a');
+ estimated | actual 
+-----------+--------
+      1667 |   5000
+(1 row)
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists WHERE a < a');
+ estimated | actual 
+-----------+--------
+      1667 |      0
+(1 row)
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists WHERE a > a');
+ estimated | actual 
+-----------+--------
+      1667 |      0
+(1 row)
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists WHERE a >= a');
+ estimated | actual 
+-----------+--------
+      1667 |   5000
+(1 row)
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists WHERE a = c');
+ estimated | actual 
+-----------+--------
+        25 |   1250
+(1 row)
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists WHERE a != c');
+ estimated | actual 
+-----------+--------
+      4975 |   3750
+(1 row)
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists WHERE a > c');
+ estimated | actual 
+-----------+--------
+      1667 |   3750
+(1 row)
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists WHERE a >= c');
+ estimated | actual 
+-----------+--------
+      1667 |   5000
+(1 row)
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists WHERE a < c');
+ estimated | actual 
+-----------+--------
+      1667 |      0
+(1 row)
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists WHERE a <= c');
+ estimated | actual 
+-----------+--------
+      1667 |   1250
+(1 row)
+
 SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists WHERE a IN (1, 2, 51, 52) AND b IN ( ''1'', ''2'')');
  estimated | actual 
 -----------+--------
@@ -2544,288 +2688,1944 @@ SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists WHERE a IS NULL AND
       3750 |   2500
 (1 row)
 
--- create statistics
-CREATE STATISTICS mcv_lists_stats (mcv) ON a, b, d FROM mcv_lists;
-ANALYZE mcv_lists;
--- test pg_mcv_list_items with MCV list containing variable-length data and NULLs
-SELECT m.*
-  FROM pg_statistic_ext s, pg_statistic_ext_data d,
-       pg_mcv_list_items(d.stxdmcv) m
- WHERE s.stxname = 'mcv_lists_stats'
-   AND d.stxoid = s.oid;
- index |      values      |  nulls  | frequency | base_frequency 
--------+------------------+---------+-----------+----------------
-     0 | {NULL,x,x}       | {t,f,f} |       0.5 |           0.25
-     1 | {NULL,NULL,NULL} | {t,t,t} |       0.5 |           0.25
-(2 rows)
-
-SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists WHERE b = ''x'' OR d = ''x''');
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists WHERE b = d');
  estimated | actual 
 -----------+--------
-      2500 |   2500
+        25 |   2500
 (1 row)
 
-SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists WHERE a = 1 OR b = ''x'' OR d = ''x''');
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists WHERE b = d AND a > a');
  estimated | actual 
 -----------+--------
-      2500 |   2500
+         8 |      0
 (1 row)
 
-SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists WHERE a IS NULL AND (b = ''x'' OR d = ''x'')');
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists WHERE b = d AND a < a');
  estimated | actual 
 -----------+--------
-      2500 |   2500
+         8 |      0
 (1 row)
 
--- mcv with pass-by-ref fixlen types, e.g. uuid
-CREATE TABLE mcv_lists_uuid (
-    a UUID,
-    b UUID,
-    c UUID
-)
-WITH (autovacuum_enabled = off);
-INSERT INTO mcv_lists_uuid (a, b, c)
-     SELECT
-         md5(mod(i,100)::text)::uuid,
-         md5(mod(i,50)::text)::uuid,
-         md5(mod(i,25)::text)::uuid
-     FROM generate_series(1,5000) s(i);
-ANALYZE mcv_lists_uuid;
-SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists_uuid WHERE a = ''1679091c-5a88-0faf-6fb5-e6087eb1b2dc'' AND b = ''1679091c-5a88-0faf-6fb5-e6087eb1b2dc''');
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists WHERE b = d AND a = a');
  estimated | actual 
 -----------+--------
-         1 |     50
+         1 |      0
 (1 row)
 
-SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists_uuid WHERE a = ''1679091c-5a88-0faf-6fb5-e6087eb1b2dc'' AND b = ''1679091c-5a88-0faf-6fb5-e6087eb1b2dc'' AND c = ''1679091c-5a88-0faf-6fb5-e6087eb1b2dc''');
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists WHERE b = d AND NOT a = a');
  estimated | actual 
 -----------+--------
-         1 |     50
+        25 |      0
 (1 row)
 
-CREATE STATISTICS mcv_lists_uuid_stats (mcv) ON a, b, c
-  FROM mcv_lists_uuid;
-ANALYZE mcv_lists_uuid;
-SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists_uuid WHERE a = ''1679091c-5a88-0faf-6fb5-e6087eb1b2dc'' AND b = ''1679091c-5a88-0faf-6fb5-e6087eb1b2dc''');
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists WHERE b = d OR a > a');
  estimated | actual 
 -----------+--------
-        50 |     50
+      1683 |   2500
 (1 row)
 
-SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists_uuid WHERE a = ''1679091c-5a88-0faf-6fb5-e6087eb1b2dc'' AND b = ''1679091c-5a88-0faf-6fb5-e6087eb1b2dc'' AND c = ''1679091c-5a88-0faf-6fb5-e6087eb1b2dc''');
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists WHERE b = d OR a < a');
  estimated | actual 
 -----------+--------
-        50 |     50
+      1683 |   2500
 (1 row)
 
-DROP TABLE mcv_lists_uuid;
--- mcv with arrays
-CREATE TABLE mcv_lists_arrays (
-    a TEXT[],
-    b NUMERIC[],
-    c INT[]
-)
-WITH (autovacuum_enabled = off);
-INSERT INTO mcv_lists_arrays (a, b, c)
-     SELECT
-         ARRAY[md5((i/100)::text), md5((i/100-1)::text), md5((i/100+1)::text)],
-         ARRAY[(i/100-1)::numeric/1000, (i/100)::numeric/1000, (i/100+1)::numeric/1000],
-         ARRAY[(i/100-1), i/100, (i/100+1)]
-     FROM generate_series(1,5000) s(i);
-CREATE STATISTICS mcv_lists_arrays_stats (mcv) ON a, b, c
-  FROM mcv_lists_arrays;
-ANALYZE mcv_lists_arrays;
--- mcv with bool
-CREATE TABLE mcv_lists_bool (
-    a BOOL,
-    b BOOL,
-    c BOOL
-)
-WITH (autovacuum_enabled = off);
-INSERT INTO mcv_lists_bool (a, b, c)
-     SELECT
-         (mod(i,2) = 0), (mod(i,4) = 0), (mod(i,8) = 0)
-     FROM generate_series(1,10000) s(i);
-ANALYZE mcv_lists_bool;
-SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists_bool WHERE a AND b AND c');
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists WHERE b = d OR a = a');
  estimated | actual 
 -----------+--------
-       156 |   1250
+        50 |   2500
 (1 row)
 
-SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists_bool WHERE NOT a AND b AND c');
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists WHERE b = d OR NOT a = a');
  estimated | actual 
 -----------+--------
-       156 |      0
+      4975 |   2500
 (1 row)
 
-SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists_bool WHERE NOT a AND NOT b AND c');
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists WHERE b != d');
  estimated | actual 
 -----------+--------
-       469 |      0
+      4975 |      0
 (1 row)
 
-SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists_bool WHERE NOT a AND b AND NOT c');
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists WHERE b != d AND a > a');
  estimated | actual 
 -----------+--------
-      1094 |      0
+      1658 |      0
 (1 row)
 
-CREATE STATISTICS mcv_lists_bool_stats (mcv) ON a, b, c
-  FROM mcv_lists_bool;
-ANALYZE mcv_lists_bool;
-SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists_bool WHERE a AND b AND c');
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists WHERE b != d AND a < a');
  estimated | actual 
 -----------+--------
-      1250 |   1250
+      1658 |      0
 (1 row)
 
-SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists_bool WHERE NOT a AND b AND c');
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists WHERE b != d AND a = a');
  estimated | actual 
 -----------+--------
          1 |      0
 (1 row)
 
-SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists_bool WHERE NOT a AND NOT b AND c');
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists WHERE b != d AND NOT a = a');
  estimated | actual 
 -----------+--------
-         1 |      0
+      4950 |      0
 (1 row)
 
-SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists_bool WHERE NOT a AND b AND NOT c');
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists WHERE b != d OR a > a');
  estimated | actual 
 -----------+--------
-         1 |      0
+      4983 |      0
 (1 row)
 
--- mcv covering just a small fraction of data
-CREATE TABLE mcv_lists_partial (
-    a INT,
-    b INT,
-    c INT
-);
--- 10 frequent groups, each with 100 elements
-INSERT INTO mcv_lists_partial (a, b, c)
-     SELECT
-         mod(i,10),
-         mod(i,10),
-         mod(i,10)
-     FROM generate_series(0,999) s(i);
--- 100 groups that will make it to the MCV list (includes the 10 frequent ones)
-INSERT INTO mcv_lists_partial (a, b, c)
-     SELECT
-         i,
-         i,
-         i
-     FROM generate_series(0,99) s(i);
--- 4000 groups in total, most of which won't make it (just a single item)
-INSERT INTO mcv_lists_partial (a, b, c)
-     SELECT
-         i,
-         i,
-         i
-     FROM generate_series(0,3999) s(i);
-ANALYZE mcv_lists_partial;
-SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists_partial WHERE a = 0 AND b = 0 AND c = 0');
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists WHERE b != d OR a < a');
  estimated | actual 
 -----------+--------
-         1 |    102
+      4983 |      0
 (1 row)
 
-SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists_partial WHERE a = 0 OR b = 0 OR c = 0');
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists WHERE b != d OR a = a');
  estimated | actual 
 -----------+--------
-       300 |    102
+      4975 |      0
 (1 row)
 
-SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists_partial WHERE a = 10 AND b = 10 AND c = 10');
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists WHERE b != d OR NOT a = a');
  estimated | actual 
 -----------+--------
-         1 |      2
+      5000 |      0
 (1 row)
 
-SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists_partial WHERE a = 10 OR b = 10 OR c = 10');
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists WHERE b < d');
  estimated | actual 
 -----------+--------
-         6 |      2
+      1667 |      0
 (1 row)
 
-SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists_partial WHERE a = 0 AND b = 0 AND c = 10');
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists WHERE b < d AND a > a');
  estimated | actual 
 -----------+--------
-         1 |      0
+       556 |      0
 (1 row)
 
-SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists_partial WHERE a = 0 OR b = 0 OR c = 10');
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists WHERE b < d AND a < a');
  estimated | actual 
 -----------+--------
-       204 |    104
+       556 |      0
 (1 row)
 
-SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists_partial WHERE (a = 0 AND b = 0 AND c = 0) OR (a = 1 AND b = 1 AND c = 1) OR (a = 2 AND b = 2 AND c = 2)');
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists WHERE b < d AND a = a');
  estimated | actual 
 -----------+--------
-         1 |    306
+         1 |      0
 (1 row)
 
-SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists_partial WHERE (a = 0 AND b = 0) OR (a = 0 AND c = 0) OR (b = 0 AND c = 0)');
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists WHERE b < d AND NOT a = a');
  estimated | actual 
 -----------+--------
-         6 |    102
+      1658 |      0
 (1 row)
 
-CREATE STATISTICS mcv_lists_partial_stats (mcv) ON a, b, c
-  FROM mcv_lists_partial;
-ANALYZE mcv_lists_partial;
-SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists_partial WHERE a = 0 AND b = 0 AND c = 0');
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists WHERE b < d OR a > a');
  estimated | actual 
 -----------+--------
-       102 |    102
+      2778 |      0
 (1 row)
 
-SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists_partial WHERE a = 0 OR b = 0 OR c = 0');
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists WHERE b < d OR a < a');
  estimated | actual 
 -----------+--------
-        96 |    102
+      2778 |      0
 (1 row)
 
-SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists_partial WHERE a = 10 AND b = 10 AND c = 10');
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists WHERE b < d OR a = a');
  estimated | actual 
 -----------+--------
-         2 |      2
+      1683 |      0
 (1 row)
 
-SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists_partial WHERE a = 10 OR b = 10 OR c = 10');
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists WHERE b < d OR NOT a = a');
  estimated | actual 
 -----------+--------
-         2 |      2
+      4983 |      0
 (1 row)
 
-SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists_partial WHERE a = 0 AND b = 0 AND c = 10');
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists WHERE b <= d');
  estimated | actual 
 -----------+--------
-         1 |      0
+      1667 |   2500
 (1 row)
 
-SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists_partial WHERE a = 0 OR b = 0 OR c = 10');
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists WHERE b <= d AND a > a');
  estimated | actual 
 -----------+--------
-       102 |    104
+       556 |      0
 (1 row)
 
-SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists_partial WHERE (a = 0 AND b = 0 AND c = 0) OR (a = 1 AND b = 1 AND c = 1) OR (a = 2 AND b = 2 AND c = 2)');
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists WHERE b <= d AND a < a');
  estimated | actual 
 -----------+--------
-       306 |    306
+       556 |      0
 (1 row)
 
-SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists_partial WHERE (a = 0 AND b = 0) OR (a = 0 AND c = 0) OR (b = 0 AND c = 0)');
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists WHERE b <= d AND a = a');
  estimated | actual 
 -----------+--------
-       108 |    102
+         1 |      0
+(1 row)
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists WHERE b <= d AND NOT a = a');
+ estimated | actual 
+-----------+--------
+      1658 |      0
+(1 row)
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists WHERE b <= d OR a > a');
+ estimated | actual 
+-----------+--------
+      2778 |   2500
+(1 row)
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists WHERE b <= d OR a < a');
+ estimated | actual 
+-----------+--------
+      2778 |   2500
+(1 row)
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists WHERE b <= d OR a = a');
+ estimated | actual 
+-----------+--------
+      1683 |   2500
+(1 row)
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists WHERE b <= d OR NOT a = a');
+ estimated | actual 
+-----------+--------
+      4983 |   2500
+(1 row)
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists WHERE b > d');
+ estimated | actual 
+-----------+--------
+      1667 |      0
+(1 row)
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists WHERE b > d AND a > a');
+ estimated | actual 
+-----------+--------
+       556 |      0
+(1 row)
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists WHERE b > d AND a < a');
+ estimated | actual 
+-----------+--------
+       556 |      0
+(1 row)
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists WHERE b > d AND a = a');
+ estimated | actual 
+-----------+--------
+         1 |      0
+(1 row)
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists WHERE b > d AND NOT a = a');
+ estimated | actual 
+-----------+--------
+      1658 |      0
+(1 row)
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists WHERE b > d OR a > a');
+ estimated | actual 
+-----------+--------
+      2778 |      0
+(1 row)
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists WHERE b > d OR a < a');
+ estimated | actual 
+-----------+--------
+      2778 |      0
+(1 row)
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists WHERE b > d OR a = a');
+ estimated | actual 
+-----------+--------
+      1683 |      0
+(1 row)
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists WHERE b > d OR NOT a = a');
+ estimated | actual 
+-----------+--------
+      4983 |      0
+(1 row)
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists WHERE b >= d');
+ estimated | actual 
+-----------+--------
+      1667 |   2500
+(1 row)
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists WHERE b >= d AND a > a');
+ estimated | actual 
+-----------+--------
+       556 |      0
+(1 row)
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists WHERE b >= d AND a < a');
+ estimated | actual 
+-----------+--------
+       556 |      0
+(1 row)
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists WHERE b >= d AND a = a');
+ estimated | actual 
+-----------+--------
+         1 |      0
+(1 row)
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists WHERE b >= d AND NOT a = a');
+ estimated | actual 
+-----------+--------
+      1658 |      0
+(1 row)
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists WHERE b >= d OR a > a');
+ estimated | actual 
+-----------+--------
+      2778 |   2500
+(1 row)
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists WHERE b >= d OR a < a');
+ estimated | actual 
+-----------+--------
+      2778 |   2500
+(1 row)
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists WHERE b >= d OR a = a');
+ estimated | actual 
+-----------+--------
+      1683 |   2500
+(1 row)
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists WHERE b >= d OR NOT a = a');
+ estimated | actual 
+-----------+--------
+      4983 |   2500
+(1 row)
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists WHERE b = d AND c > c');
+ estimated | actual 
+-----------+--------
+         8 |      0
+(1 row)
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists WHERE b = d AND c < c');
+ estimated | actual 
+-----------+--------
+         8 |      0
+(1 row)
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists WHERE b = d AND c = c');
+ estimated | actual 
+-----------+--------
+        12 |   2500
+(1 row)
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists WHERE b = d AND NOT c = c');
+ estimated | actual 
+-----------+--------
+        25 |      0
+(1 row)
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists WHERE b = d OR c > c');
+ estimated | actual 
+-----------+--------
+      1683 |   2500
+(1 row)
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists WHERE b = d OR c < c');
+ estimated | actual 
+-----------+--------
+      1683 |   2500
+(1 row)
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists WHERE b = d OR c = c');
+ estimated | actual 
+-----------+--------
+        50 |   2500
+(1 row)
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists WHERE b = d OR NOT c = c');
+ estimated | actual 
+-----------+--------
+      4975 |   2500
+(1 row)
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists WHERE b != d');
+ estimated | actual 
+-----------+--------
+      4975 |      0
+(1 row)
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists WHERE b != d AND c > c');
+ estimated | actual 
+-----------+--------
+      1658 |      0
+(1 row)
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists WHERE b != d AND c < c');
+ estimated | actual 
+-----------+--------
+      1658 |      0
+(1 row)
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists WHERE b != d AND c = c');
+ estimated | actual 
+-----------+--------
+      2488 |      0
+(1 row)
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists WHERE b != d AND NOT c = c');
+ estimated | actual 
+-----------+--------
+      4950 |      0
+(1 row)
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists WHERE b != d OR c > c');
+ estimated | actual 
+-----------+--------
+      4983 |      0
+(1 row)
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists WHERE b != d OR c < c');
+ estimated | actual 
+-----------+--------
+      4983 |      0
+(1 row)
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists WHERE b != d OR c = c');
+ estimated | actual 
+-----------+--------
+      4975 |   2500
+(1 row)
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists WHERE b != d OR NOT c = c');
+ estimated | actual 
+-----------+--------
+      5000 |      0
+(1 row)
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists WHERE b < d');
+ estimated | actual 
+-----------+--------
+      1667 |      0
+(1 row)
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists WHERE b < d AND c > c');
+ estimated | actual 
+-----------+--------
+       556 |      0
+(1 row)
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists WHERE b < d AND c < c');
+ estimated | actual 
+-----------+--------
+       556 |      0
+(1 row)
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists WHERE b < d AND c = c');
+ estimated | actual 
+-----------+--------
+       833 |      0
+(1 row)
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists WHERE b < d AND NOT c = c');
+ estimated | actual 
+-----------+--------
+      1658 |      0
+(1 row)
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists WHERE b < d OR c > c');
+ estimated | actual 
+-----------+--------
+      2778 |      0
+(1 row)
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists WHERE b < d OR c < c');
+ estimated | actual 
+-----------+--------
+      2778 |      0
+(1 row)
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists WHERE b < d OR c = c');
+ estimated | actual 
+-----------+--------
+      1683 |   2500
+(1 row)
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists WHERE b < d OR NOT c = c');
+ estimated | actual 
+-----------+--------
+      4983 |      0
+(1 row)
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists WHERE b <= d');
+ estimated | actual 
+-----------+--------
+      1667 |   2500
+(1 row)
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists WHERE b <= d AND c > c');
+ estimated | actual 
+-----------+--------
+       556 |      0
+(1 row)
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists WHERE b <= d AND c < c');
+ estimated | actual 
+-----------+--------
+       556 |      0
+(1 row)
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists WHERE b <= d AND c = c');
+ estimated | actual 
+-----------+--------
+       833 |   2500
+(1 row)
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists WHERE b <= d AND NOT c = c');
+ estimated | actual 
+-----------+--------
+      1658 |      0
+(1 row)
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists WHERE b <= d OR c > c');
+ estimated | actual 
+-----------+--------
+      2778 |   2500
+(1 row)
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists WHERE b <= d OR c < c');
+ estimated | actual 
+-----------+--------
+      2778 |   2500
+(1 row)
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists WHERE b <= d OR c = c');
+ estimated | actual 
+-----------+--------
+      1683 |   2500
+(1 row)
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists WHERE b <= d OR NOT c = c');
+ estimated | actual 
+-----------+--------
+      4983 |   2500
+(1 row)
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists WHERE b > d');
+ estimated | actual 
+-----------+--------
+      1667 |      0
+(1 row)
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists WHERE b > d AND c > c');
+ estimated | actual 
+-----------+--------
+       556 |      0
+(1 row)
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists WHERE b > d AND c < c');
+ estimated | actual 
+-----------+--------
+       556 |      0
+(1 row)
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists WHERE b > d AND c = c');
+ estimated | actual 
+-----------+--------
+       833 |      0
+(1 row)
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists WHERE b > d AND NOT c = c');
+ estimated | actual 
+-----------+--------
+      1658 |      0
+(1 row)
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists WHERE b > d OR c > c');
+ estimated | actual 
+-----------+--------
+      2778 |      0
+(1 row)
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists WHERE b > d OR c < c');
+ estimated | actual 
+-----------+--------
+      2778 |      0
+(1 row)
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists WHERE b > d OR c = c');
+ estimated | actual 
+-----------+--------
+      1683 |   2500
+(1 row)
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists WHERE b > d OR NOT c = c');
+ estimated | actual 
+-----------+--------
+      4983 |      0
+(1 row)
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists WHERE b >= d');
+ estimated | actual 
+-----------+--------
+      1667 |   2500
+(1 row)
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists WHERE b >= d AND c > c');
+ estimated | actual 
+-----------+--------
+       556 |      0
+(1 row)
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists WHERE b >= d AND c < c');
+ estimated | actual 
+-----------+--------
+       556 |      0
+(1 row)
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists WHERE b >= d AND c = c');
+ estimated | actual 
+-----------+--------
+       833 |   2500
+(1 row)
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists WHERE b >= d AND NOT c = c');
+ estimated | actual 
+-----------+--------
+      1658 |      0
+(1 row)
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists WHERE b >= d OR c > c');
+ estimated | actual 
+-----------+--------
+      2778 |   2500
+(1 row)
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists WHERE b >= d OR c < c');
+ estimated | actual 
+-----------+--------
+      2778 |   2500
+(1 row)
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists WHERE b >= d OR c = c');
+ estimated | actual 
+-----------+--------
+      1683 |   2500
+(1 row)
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists WHERE b >= d OR NOT c = c');
+ estimated | actual 
+-----------+--------
+      4983 |   2500
+(1 row)
+
+-- create statistics
+CREATE STATISTICS mcv_lists_stats (mcv) ON a, b, d FROM mcv_lists;
+ANALYZE mcv_lists;
+-- test pg_mcv_list_items with MCV list containing variable-length data and NULLs
+SELECT m.*
+  FROM pg_statistic_ext s, pg_statistic_ext_data d,
+       pg_mcv_list_items(d.stxdmcv) m
+ WHERE s.stxname = 'mcv_lists_stats'
+   AND d.stxoid = s.oid;
+ index |      values      |  nulls  | frequency | base_frequency 
+-------+------------------+---------+-----------+----------------
+     0 | {NULL,x,x}       | {t,f,f} |       0.5 |           0.25
+     1 | {NULL,NULL,NULL} | {t,t,t} |       0.5 |           0.25
+(2 rows)
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists WHERE b = ''x'' OR d = ''x''');
+ estimated | actual 
+-----------+--------
+      2500 |   2500
+(1 row)
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists WHERE a = 1 OR b = ''x'' OR d = ''x''');
+ estimated | actual 
+-----------+--------
+      2500 |   2500
+(1 row)
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists WHERE a IS NULL AND (b = ''x'' OR d = ''x'')');
+ estimated | actual 
+-----------+--------
+      2500 |   2500
+(1 row)
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists WHERE b = d');
+ estimated | actual 
+-----------+--------
+        25 |   2500
+(1 row)
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists WHERE b = d AND a > a');
+ estimated | actual 
+-----------+--------
+         8 |      0
+(1 row)
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists WHERE b = d AND a < a');
+ estimated | actual 
+-----------+--------
+         8 |      0
+(1 row)
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists WHERE b = d AND a = a');
+ estimated | actual 
+-----------+--------
+         1 |      0
+(1 row)
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists WHERE b = d AND NOT a = a');
+ estimated | actual 
+-----------+--------
+        25 |      0
+(1 row)
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists WHERE b = d OR a > a');
+ estimated | actual 
+-----------+--------
+      1683 |   2500
+(1 row)
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists WHERE b = d OR a < a');
+ estimated | actual 
+-----------+--------
+      1683 |   2500
+(1 row)
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists WHERE b = d OR a = a');
+ estimated | actual 
+-----------+--------
+        50 |   2500
+(1 row)
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists WHERE b = d OR NOT a = a');
+ estimated | actual 
+-----------+--------
+      4975 |   2500
+(1 row)
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists WHERE b != d');
+ estimated | actual 
+-----------+--------
+      4975 |      0
+(1 row)
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists WHERE b != d AND a > a');
+ estimated | actual 
+-----------+--------
+      1658 |      0
+(1 row)
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists WHERE b != d AND a < a');
+ estimated | actual 
+-----------+--------
+      1658 |      0
+(1 row)
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists WHERE b != d AND a = a');
+ estimated | actual 
+-----------+--------
+         1 |      0
+(1 row)
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists WHERE b != d AND NOT a = a');
+ estimated | actual 
+-----------+--------
+      4950 |      0
+(1 row)
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists WHERE b != d OR a > a');
+ estimated | actual 
+-----------+--------
+      4983 |      0
+(1 row)
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists WHERE b != d OR a < a');
+ estimated | actual 
+-----------+--------
+      4983 |      0
+(1 row)
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists WHERE b != d OR a = a');
+ estimated | actual 
+-----------+--------
+      4975 |      0
+(1 row)
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists WHERE b != d OR NOT a = a');
+ estimated | actual 
+-----------+--------
+      5000 |      0
+(1 row)
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists WHERE b < d');
+ estimated | actual 
+-----------+--------
+      1667 |      0
+(1 row)
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists WHERE b < d AND a > a');
+ estimated | actual 
+-----------+--------
+       556 |      0
+(1 row)
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists WHERE b < d AND a < a');
+ estimated | actual 
+-----------+--------
+       556 |      0
+(1 row)
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists WHERE b < d AND a = a');
+ estimated | actual 
+-----------+--------
+         1 |      0
+(1 row)
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists WHERE b < d AND NOT a = a');
+ estimated | actual 
+-----------+--------
+      1658 |      0
+(1 row)
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists WHERE b < d OR a > a');
+ estimated | actual 
+-----------+--------
+      2778 |      0
+(1 row)
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists WHERE b < d OR a < a');
+ estimated | actual 
+-----------+--------
+      2778 |      0
+(1 row)
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists WHERE b < d OR a = a');
+ estimated | actual 
+-----------+--------
+      1683 |      0
+(1 row)
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists WHERE b < d OR NOT a = a');
+ estimated | actual 
+-----------+--------
+      4983 |      0
+(1 row)
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists WHERE b <= d');
+ estimated | actual 
+-----------+--------
+      1667 |   2500
+(1 row)
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists WHERE b <= d AND a > a');
+ estimated | actual 
+-----------+--------
+       556 |      0
+(1 row)
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists WHERE b <= d AND a < a');
+ estimated | actual 
+-----------+--------
+       556 |      0
+(1 row)
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists WHERE b <= d AND a = a');
+ estimated | actual 
+-----------+--------
+         1 |      0
+(1 row)
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists WHERE b <= d AND NOT a = a');
+ estimated | actual 
+-----------+--------
+      1658 |      0
+(1 row)
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists WHERE b <= d OR a > a');
+ estimated | actual 
+-----------+--------
+      2778 |   2500
+(1 row)
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists WHERE b <= d OR a < a');
+ estimated | actual 
+-----------+--------
+      2778 |   2500
+(1 row)
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists WHERE b <= d OR a = a');
+ estimated | actual 
+-----------+--------
+      1683 |   2500
+(1 row)
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists WHERE b <= d OR NOT a = a');
+ estimated | actual 
+-----------+--------
+      4983 |   2500
+(1 row)
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists WHERE b > d');
+ estimated | actual 
+-----------+--------
+      1667 |      0
+(1 row)
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists WHERE b > d AND a > a');
+ estimated | actual 
+-----------+--------
+       556 |      0
+(1 row)
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists WHERE b > d AND a < a');
+ estimated | actual 
+-----------+--------
+       556 |      0
+(1 row)
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists WHERE b > d AND a = a');
+ estimated | actual 
+-----------+--------
+         1 |      0
+(1 row)
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists WHERE b > d AND NOT a = a');
+ estimated | actual 
+-----------+--------
+      1658 |      0
+(1 row)
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists WHERE b > d OR a > a');
+ estimated | actual 
+-----------+--------
+      2778 |      0
+(1 row)
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists WHERE b > d OR a < a');
+ estimated | actual 
+-----------+--------
+      2778 |      0
+(1 row)
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists WHERE b > d OR a = a');
+ estimated | actual 
+-----------+--------
+      1683 |      0
+(1 row)
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists WHERE b > d OR NOT a = a');
+ estimated | actual 
+-----------+--------
+      4983 |      0
+(1 row)
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists WHERE b >= d');
+ estimated | actual 
+-----------+--------
+      1667 |   2500
+(1 row)
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists WHERE b >= d AND a > a');
+ estimated | actual 
+-----------+--------
+       556 |      0
+(1 row)
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists WHERE b >= d AND a < a');
+ estimated | actual 
+-----------+--------
+       556 |      0
+(1 row)
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists WHERE b >= d AND a = a');
+ estimated | actual 
+-----------+--------
+         1 |      0
+(1 row)
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists WHERE b >= d AND NOT a = a');
+ estimated | actual 
+-----------+--------
+      1658 |      0
+(1 row)
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists WHERE b >= d OR a > a');
+ estimated | actual 
+-----------+--------
+      2778 |   2500
+(1 row)
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists WHERE b >= d OR a < a');
+ estimated | actual 
+-----------+--------
+      2778 |   2500
+(1 row)
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists WHERE b >= d OR a = a');
+ estimated | actual 
+-----------+--------
+      1683 |   2500
+(1 row)
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists WHERE b >= d OR NOT a = a');
+ estimated | actual 
+-----------+--------
+      4983 |   2500
+(1 row)
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists WHERE b = d AND c > c');
+ estimated | actual 
+-----------+--------
+         8 |      0
+(1 row)
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists WHERE b = d AND c < c');
+ estimated | actual 
+-----------+--------
+         8 |      0
+(1 row)
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists WHERE b = d AND c = c');
+ estimated | actual 
+-----------+--------
+        12 |   2500
+(1 row)
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists WHERE b = d AND NOT c = c');
+ estimated | actual 
+-----------+--------
+        25 |      0
+(1 row)
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists WHERE b = d OR c > c');
+ estimated | actual 
+-----------+--------
+      1683 |   2500
+(1 row)
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists WHERE b = d OR c < c');
+ estimated | actual 
+-----------+--------
+      1683 |   2500
+(1 row)
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists WHERE b = d OR c = c');
+ estimated | actual 
+-----------+--------
+        50 |   2500
+(1 row)
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists WHERE b = d OR NOT c = c');
+ estimated | actual 
+-----------+--------
+      4975 |   2500
+(1 row)
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists WHERE b != d');
+ estimated | actual 
+-----------+--------
+      4975 |      0
+(1 row)
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists WHERE b != d AND c > c');
+ estimated | actual 
+-----------+--------
+      1658 |      0
+(1 row)
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists WHERE b != d AND c < c');
+ estimated | actual 
+-----------+--------
+      1658 |      0
+(1 row)
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists WHERE b != d AND c = c');
+ estimated | actual 
+-----------+--------
+      2488 |      0
+(1 row)
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists WHERE b != d AND NOT c = c');
+ estimated | actual 
+-----------+--------
+      4950 |      0
+(1 row)
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists WHERE b != d OR c > c');
+ estimated | actual 
+-----------+--------
+      4983 |      0
+(1 row)
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists WHERE b != d OR c < c');
+ estimated | actual 
+-----------+--------
+      4983 |      0
+(1 row)
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists WHERE b != d OR c = c');
+ estimated | actual 
+-----------+--------
+      4975 |   2500
+(1 row)
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists WHERE b != d OR NOT c = c');
+ estimated | actual 
+-----------+--------
+      5000 |      0
+(1 row)
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists WHERE b < d');
+ estimated | actual 
+-----------+--------
+      1667 |      0
+(1 row)
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists WHERE b < d AND c > c');
+ estimated | actual 
+-----------+--------
+       556 |      0
+(1 row)
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists WHERE b < d AND c < c');
+ estimated | actual 
+-----------+--------
+       556 |      0
+(1 row)
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists WHERE b < d AND c = c');
+ estimated | actual 
+-----------+--------
+       833 |      0
+(1 row)
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists WHERE b < d AND NOT c = c');
+ estimated | actual 
+-----------+--------
+      1658 |      0
+(1 row)
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists WHERE b < d OR c > c');
+ estimated | actual 
+-----------+--------
+      2778 |      0
+(1 row)
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists WHERE b < d OR c < c');
+ estimated | actual 
+-----------+--------
+      2778 |      0
+(1 row)
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists WHERE b < d OR c = c');
+ estimated | actual 
+-----------+--------
+      1683 |   2500
+(1 row)
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists WHERE b < d OR NOT c = c');
+ estimated | actual 
+-----------+--------
+      4983 |      0
+(1 row)
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists WHERE b <= d');
+ estimated | actual 
+-----------+--------
+      1667 |   2500
+(1 row)
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists WHERE b <= d AND c > c');
+ estimated | actual 
+-----------+--------
+       556 |      0
+(1 row)
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists WHERE b <= d AND c < c');
+ estimated | actual 
+-----------+--------
+       556 |      0
+(1 row)
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists WHERE b <= d AND c = c');
+ estimated | actual 
+-----------+--------
+       833 |   2500
+(1 row)
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists WHERE b <= d AND NOT c = c');
+ estimated | actual 
+-----------+--------
+      1658 |      0
+(1 row)
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists WHERE b <= d OR c > c');
+ estimated | actual 
+-----------+--------
+      2778 |   2500
+(1 row)
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists WHERE b <= d OR c < c');
+ estimated | actual 
+-----------+--------
+      2778 |   2500
+(1 row)
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists WHERE b <= d OR c = c');
+ estimated | actual 
+-----------+--------
+      1683 |   2500
+(1 row)
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists WHERE b <= d OR NOT c = c');
+ estimated | actual 
+-----------+--------
+      4983 |   2500
+(1 row)
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists WHERE b > d');
+ estimated | actual 
+-----------+--------
+      1667 |      0
+(1 row)
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists WHERE b > d AND c > c');
+ estimated | actual 
+-----------+--------
+       556 |      0
+(1 row)
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists WHERE b > d AND c < c');
+ estimated | actual 
+-----------+--------
+       556 |      0
+(1 row)
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists WHERE b > d AND c = c');
+ estimated | actual 
+-----------+--------
+       833 |      0
+(1 row)
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists WHERE b > d AND NOT c = c');
+ estimated | actual 
+-----------+--------
+      1658 |      0
+(1 row)
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists WHERE b > d OR c > c');
+ estimated | actual 
+-----------+--------
+      2778 |      0
+(1 row)
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists WHERE b > d OR c < c');
+ estimated | actual 
+-----------+--------
+      2778 |      0
+(1 row)
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists WHERE b > d OR c = c');
+ estimated | actual 
+-----------+--------
+      1683 |   2500
+(1 row)
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists WHERE b > d OR NOT c = c');
+ estimated | actual 
+-----------+--------
+      4983 |      0
+(1 row)
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists WHERE b >= d');
+ estimated | actual 
+-----------+--------
+      1667 |   2500
+(1 row)
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists WHERE b >= d AND c > c');
+ estimated | actual 
+-----------+--------
+       556 |      0
+(1 row)
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists WHERE b >= d AND c < c');
+ estimated | actual 
+-----------+--------
+       556 |      0
+(1 row)
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists WHERE b >= d AND c = c');
+ estimated | actual 
+-----------+--------
+       833 |   2500
+(1 row)
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists WHERE b >= d AND NOT c = c');
+ estimated | actual 
+-----------+--------
+      1658 |      0
+(1 row)
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists WHERE b >= d OR c > c');
+ estimated | actual 
+-----------+--------
+      2778 |   2500
+(1 row)
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists WHERE b >= d OR c < c');
+ estimated | actual 
+-----------+--------
+      2778 |   2500
+(1 row)
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists WHERE b >= d OR c = c');
+ estimated | actual 
+-----------+--------
+      1683 |   2500
+(1 row)
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists WHERE b >= d OR NOT c = c');
+ estimated | actual 
+-----------+--------
+      4983 |   2500
+(1 row)
+
+-- mcv with pass-by-ref fixlen types, e.g. uuid
+CREATE TABLE mcv_lists_uuid (
+    a UUID,
+    b UUID,
+    c UUID
+)
+WITH (autovacuum_enabled = off);
+INSERT INTO mcv_lists_uuid (a, b, c)
+     SELECT
+         md5(mod(i,100)::text)::uuid,
+         md5(mod(i,50)::text)::uuid,
+         md5(mod(i,25)::text)::uuid
+     FROM generate_series(1,5000) s(i);
+ANALYZE mcv_lists_uuid;
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists_uuid WHERE a = ''1679091c-5a88-0faf-6fb5-e6087eb1b2dc'' AND b = ''1679091c-5a88-0faf-6fb5-e6087eb1b2dc''');
+ estimated | actual 
+-----------+--------
+         1 |     50
+(1 row)
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists_uuid WHERE a = ''1679091c-5a88-0faf-6fb5-e6087eb1b2dc'' AND b = ''1679091c-5a88-0faf-6fb5-e6087eb1b2dc'' AND c = ''1679091c-5a88-0faf-6fb5-e6087eb1b2dc''');
+ estimated | actual 
+-----------+--------
+         1 |     50
+(1 row)
+
+CREATE STATISTICS mcv_lists_uuid_stats (mcv) ON a, b, c
+  FROM mcv_lists_uuid;
+ANALYZE mcv_lists_uuid;
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists_uuid WHERE a = ''1679091c-5a88-0faf-6fb5-e6087eb1b2dc'' AND b = ''1679091c-5a88-0faf-6fb5-e6087eb1b2dc''');
+ estimated | actual 
+-----------+--------
+        50 |     50
+(1 row)
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists_uuid WHERE a = ''1679091c-5a88-0faf-6fb5-e6087eb1b2dc'' AND b = ''1679091c-5a88-0faf-6fb5-e6087eb1b2dc'' AND c = ''1679091c-5a88-0faf-6fb5-e6087eb1b2dc''');
+ estimated | actual 
+-----------+--------
+        50 |     50
+(1 row)
+
+DROP TABLE mcv_lists_uuid;
+-- mcv with arrays
+CREATE TABLE mcv_lists_arrays (
+    a TEXT[],
+    b NUMERIC[],
+    c INT[]
+)
+WITH (autovacuum_enabled = off);
+INSERT INTO mcv_lists_arrays (a, b, c)
+     SELECT
+         ARRAY[md5((i/100)::text), md5((i/100-1)::text), md5((i/100+1)::text)],
+         ARRAY[(i/100-1)::numeric/1000, (i/100)::numeric/1000, (i/100+1)::numeric/1000],
+         ARRAY[(i/100-1), i/100, (i/100+1)]
+     FROM generate_series(1,5000) s(i);
+CREATE STATISTICS mcv_lists_arrays_stats (mcv) ON a, b, c
+  FROM mcv_lists_arrays;
+ANALYZE mcv_lists_arrays;
+-- mcv with bool
+CREATE TABLE mcv_lists_bool (
+    a BOOL,
+    b BOOL,
+    c BOOL
+)
+WITH (autovacuum_enabled = off);
+INSERT INTO mcv_lists_bool (a, b, c)
+     SELECT
+         (mod(i,2) = 0), (mod(i,4) = 0), (mod(i,8) = 0)
+     FROM generate_series(1,10000) s(i);
+ANALYZE mcv_lists_bool;
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists_bool WHERE a AND b AND c');
+ estimated | actual 
+-----------+--------
+       156 |   1250
+(1 row)
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists_bool WHERE NOT a AND b AND c');
+ estimated | actual 
+-----------+--------
+       156 |      0
+(1 row)
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists_bool WHERE NOT a AND NOT b AND c');
+ estimated | actual 
+-----------+--------
+       469 |      0
+(1 row)
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists_bool WHERE NOT a AND b AND NOT c');
+ estimated | actual 
+-----------+--------
+      1094 |      0
+(1 row)
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists_bool WHERE NOT a = a');
+ estimated | actual 
+-----------+--------
+      9950 |      0
+(1 row)
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists_bool WHERE NOT a != a');
+ estimated | actual 
+-----------+--------
+     10000 |  10000
+(1 row)
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists_bool WHERE NOT a < a');
+ estimated | actual 
+-----------+--------
+      3333 |  10000
+(1 row)
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists_bool WHERE NOT a <= a');
+ estimated | actual 
+-----------+--------
+      3333 |      0
+(1 row)
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists_bool WHERE NOT a > a');
+ estimated | actual 
+-----------+--------
+      3333 |  10000
+(1 row)
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists_bool WHERE NOT a >= a');
+ estimated | actual 
+-----------+--------
+      3333 |      0
+(1 row)
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists_bool WHERE NOT a = b');
+ estimated | actual 
+-----------+--------
+      9950 |   2500
+(1 row)
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists_bool WHERE NOT a != b');
+ estimated | actual 
+-----------+--------
+        50 |   7500
+(1 row)
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists_bool WHERE NOT a < b');
+ estimated | actual 
+-----------+--------
+      3333 |  10000
+(1 row)
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists_bool WHERE NOT a <= b');
+ estimated | actual 
+-----------+--------
+      3333 |   2500
+(1 row)
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists_bool WHERE NOT a > b');
+ estimated | actual 
+-----------+--------
+      3333 |   7500
+(1 row)
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists_bool WHERE NOT a >= b');
+ estimated | actual 
+-----------+--------
+      3333 |      0
+(1 row)
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists_bool WHERE NOT a = a AND b = b');
+ estimated | actual 
+-----------+--------
+      9950 |      0
+(1 row)
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists_bool WHERE NOT a != a AND b != b');
+ estimated | actual 
+-----------+--------
+      9950 |      0
+(1 row)
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists_bool WHERE NOT a < a AND b < b');
+ estimated | actual 
+-----------+--------
+      1111 |      0
+(1 row)
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists_bool WHERE NOT a <= a AND b <= b');
+ estimated | actual 
+-----------+--------
+      1111 |      0
+(1 row)
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists_bool WHERE NOT a > a AND b > b');
+ estimated | actual 
+-----------+--------
+      1111 |      0
+(1 row)
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists_bool WHERE NOT a >= a AND b >= b');
+ estimated | actual 
+-----------+--------
+      1111 |      0
+(1 row)
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists_bool WHERE NOT a = b AND b = c');
+ estimated | actual 
+-----------+--------
+        50 |   2500
+(1 row)
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists_bool WHERE NOT a != b AND b != c');
+ estimated | actual 
+-----------+--------
+        50 |   1250
+(1 row)
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists_bool WHERE NOT a < b AND b < c');
+ estimated | actual 
+-----------+--------
+      1111 |      0
+(1 row)
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists_bool WHERE NOT a <= b AND b <= c');
+ estimated | actual 
+-----------+--------
+      1111 |   2500
+(1 row)
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists_bool WHERE NOT a > b AND b > c');
+ estimated | actual 
+-----------+--------
+      1111 |   1250
+(1 row)
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists_bool WHERE NOT a >= b AND b >= c');
+ estimated | actual 
+-----------+--------
+      1111 |      0
+(1 row)
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists_bool WHERE NOT a = c AND b = b');
+ estimated | actual 
+-----------+--------
+      9950 |   3750
+(1 row)
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists_bool WHERE NOT a != c AND b != b');
+ estimated | actual 
+-----------+--------
+        50 |      0
+(1 row)
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists_bool WHERE NOT a < c AND b < b');
+ estimated | actual 
+-----------+--------
+      1111 |      0
+(1 row)
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists_bool WHERE NOT a <= a AND b <= c');
+ estimated | actual 
+-----------+--------
+      1111 |      0
+(1 row)
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists_bool WHERE NOT a > a AND b > c');
+ estimated | actual 
+-----------+--------
+      1111 |   1250
+(1 row)
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists_bool WHERE NOT a >= a AND b >= c');
+ estimated | actual 
+-----------+--------
+      1111 |      0
+(1 row)
+
+CREATE STATISTICS mcv_lists_bool_stats (mcv) ON a, b, c
+  FROM mcv_lists_bool;
+ANALYZE mcv_lists_bool;
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists_bool WHERE a AND b AND c');
+ estimated | actual 
+-----------+--------
+      1250 |   1250
+(1 row)
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists_bool WHERE NOT a AND b AND c');
+ estimated | actual 
+-----------+--------
+         1 |      0
+(1 row)
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists_bool WHERE NOT a AND NOT b AND c');
+ estimated | actual 
+-----------+--------
+         1 |      0
+(1 row)
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists_bool WHERE NOT a AND b AND NOT c');
+ estimated | actual 
+-----------+--------
+         1 |      0
+(1 row)
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists_bool WHERE NOT a = a');
+ estimated | actual 
+-----------+--------
+      9950 |      0
+(1 row)
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists_bool WHERE NOT a != a');
+ estimated | actual 
+-----------+--------
+     10000 |  10000
+(1 row)
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists_bool WHERE NOT a < a');
+ estimated | actual 
+-----------+--------
+      3333 |  10000
+(1 row)
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists_bool WHERE NOT a <= a');
+ estimated | actual 
+-----------+--------
+      3333 |      0
+(1 row)
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists_bool WHERE NOT a > a');
+ estimated | actual 
+-----------+--------
+      3333 |  10000
+(1 row)
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists_bool WHERE NOT a >= a');
+ estimated | actual 
+-----------+--------
+      3333 |      0
+(1 row)
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists_bool WHERE NOT a = b');
+ estimated | actual 
+-----------+--------
+      9950 |   2500
+(1 row)
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists_bool WHERE NOT a != b');
+ estimated | actual 
+-----------+--------
+        50 |   7500
+(1 row)
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists_bool WHERE NOT a < b');
+ estimated | actual 
+-----------+--------
+      3333 |  10000
+(1 row)
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists_bool WHERE NOT a <= b');
+ estimated | actual 
+-----------+--------
+      3333 |   2500
+(1 row)
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists_bool WHERE NOT a > b');
+ estimated | actual 
+-----------+--------
+      3333 |   7500
+(1 row)
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists_bool WHERE NOT a >= b');
+ estimated | actual 
+-----------+--------
+      3333 |      0
+(1 row)
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists_bool WHERE NOT a = a AND b = b');
+ estimated | actual 
+-----------+--------
+      9950 |      0
+(1 row)
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists_bool WHERE NOT a != a AND b != b');
+ estimated | actual 
+-----------+--------
+      9950 |      0
+(1 row)
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists_bool WHERE NOT a < a AND b < b');
+ estimated | actual 
+-----------+--------
+      1111 |      0
+(1 row)
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists_bool WHERE NOT a <= a AND b <= b');
+ estimated | actual 
+-----------+--------
+      1111 |      0
+(1 row)
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists_bool WHERE NOT a > a AND b > b');
+ estimated | actual 
+-----------+--------
+      1111 |      0
+(1 row)
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists_bool WHERE NOT a >= a AND b >= b');
+ estimated | actual 
+-----------+--------
+      1111 |      0
+(1 row)
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists_bool WHERE NOT a = b AND b = c');
+ estimated | actual 
+-----------+--------
+        50 |   2500
+(1 row)
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists_bool WHERE NOT a != b AND b != c');
+ estimated | actual 
+-----------+--------
+        50 |   1250
+(1 row)
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists_bool WHERE NOT a < b AND b < c');
+ estimated | actual 
+-----------+--------
+      1111 |      0
+(1 row)
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists_bool WHERE NOT a <= b AND b <= c');
+ estimated | actual 
+-----------+--------
+      1111 |   2500
+(1 row)
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists_bool WHERE NOT a > b AND b > c');
+ estimated | actual 
+-----------+--------
+      1111 |   1250
+(1 row)
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists_bool WHERE NOT a >= b AND b >= c');
+ estimated | actual 
+-----------+--------
+      1111 |      0
+(1 row)
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists_bool WHERE NOT a = c AND b = b');
+ estimated | actual 
+-----------+--------
+      9950 |   3750
+(1 row)
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists_bool WHERE NOT a != c AND b != b');
+ estimated | actual 
+-----------+--------
+        50 |      0
+(1 row)
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists_bool WHERE NOT a < c AND b < b');
+ estimated | actual 
+-----------+--------
+      1111 |      0
+(1 row)
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists_bool WHERE NOT a <= a AND b <= c');
+ estimated | actual 
+-----------+--------
+      1111 |      0
+(1 row)
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists_bool WHERE NOT a > a AND b > c');
+ estimated | actual 
+-----------+--------
+      1111 |   1250
+(1 row)
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists_bool WHERE NOT a >= a AND b >= c');
+ estimated | actual 
+-----------+--------
+      1111 |      0
+(1 row)
+
+-- mcv covering just a small fraction of data
+CREATE TABLE mcv_lists_partial (
+    a INT,
+    b INT,
+    c INT
+);
+-- 10 frequent groups, each with 100 elements
+INSERT INTO mcv_lists_partial (a, b, c)
+     SELECT
+         mod(i,10),
+         mod(i,10),
+         mod(i,10)
+     FROM generate_series(0,999) s(i);
+-- 100 groups that will make it to the MCV list (includes the 10 frequent ones)
+INSERT INTO mcv_lists_partial (a, b, c)
+     SELECT
+         i,
+         i,
+         i
+     FROM generate_series(0,99) s(i);
+-- 4000 groups in total, most of which won't make it (just a single item)
+INSERT INTO mcv_lists_partial (a, b, c)
+     SELECT
+         i,
+         i,
+         i
+     FROM generate_series(0,3999) s(i);
+ANALYZE mcv_lists_partial;
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists_partial WHERE a = 0 AND b = 0 AND c = 0');
+ estimated | actual 
+-----------+--------
+         1 |    102
+(1 row)
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists_partial WHERE a = 0 OR b = 0 OR c = 0');
+ estimated | actual 
+-----------+--------
+       300 |    102
+(1 row)
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists_partial WHERE a = 10 AND b = 10 AND c = 10');
+ estimated | actual 
+-----------+--------
+         1 |      2
+(1 row)
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists_partial WHERE a = 10 OR b = 10 OR c = 10');
+ estimated | actual 
+-----------+--------
+         6 |      2
+(1 row)
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists_partial WHERE a = 0 AND b = 0 AND c = 10');
+ estimated | actual 
+-----------+--------
+         1 |      0
+(1 row)
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists_partial WHERE a = 0 OR b = 0 OR c = 10');
+ estimated | actual 
+-----------+--------
+       204 |    104
+(1 row)
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists_partial WHERE (a = 0 AND b = 0 AND c = 0) OR (a = 1 AND b = 1 AND c = 1) OR (a = 2 AND b = 2 AND c = 2)');
+ estimated | actual 
+-----------+--------
+         1 |    306
+(1 row)
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists_partial WHERE (a = 0 AND b = 0) OR (a = 0 AND c = 0) OR (b = 0 AND c = 0)');
+ estimated | actual 
+-----------+--------
+         6 |    102
+(1 row)
+
+CREATE STATISTICS mcv_lists_partial_stats (mcv) ON a, b, c
+  FROM mcv_lists_partial;
+ANALYZE mcv_lists_partial;
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists_partial WHERE a = 0 AND b = 0 AND c = 0');
+ estimated | actual 
+-----------+--------
+       102 |    102
+(1 row)
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists_partial WHERE a = 0 OR b = 0 OR c = 0');
+ estimated | actual 
+-----------+--------
+        96 |    102
+(1 row)
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists_partial WHERE a = 10 AND b = 10 AND c = 10');
+ estimated | actual 
+-----------+--------
+         2 |      2
+(1 row)
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists_partial WHERE a = 10 OR b = 10 OR c = 10');
+ estimated | actual 
+-----------+--------
+         2 |      2
+(1 row)
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists_partial WHERE a = 0 AND b = 0 AND c = 10');
+ estimated | actual 
+-----------+--------
+         1 |      0
+(1 row)
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists_partial WHERE a = 0 OR b = 0 OR c = 10');
+ estimated | actual 
+-----------+--------
+       102 |    104
+(1 row)
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists_partial WHERE (a = 0 AND b = 0 AND c = 0) OR (a = 1 AND b = 1 AND c = 1) OR (a = 2 AND b = 2 AND c = 2)');
+ estimated | actual 
+-----------+--------
+       306 |    306
+(1 row)
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists_partial WHERE (a = 0 AND b = 0) OR (a = 0 AND c = 0) OR (b = 0 AND c = 0)');
+ estimated | actual 
+-----------+--------
+       108 |    102
+(1 row)
+
+DROP TABLE mcv_lists_partial;
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists_bool WHERE NOT a = b');
+ estimated | actual 
+-----------+--------
+      9950 |   2500
+(1 row)
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists_bool WHERE NOT a = b AND b = c');
+ estimated | actual 
+-----------+--------
+        50 |   2500
 (1 row)
 
-DROP TABLE mcv_lists_partial;
 -- check the ability to use multiple MCV lists
 CREATE TABLE mcv_lists_multi (
 	a INTEGER,
@@ -2885,6 +4685,126 @@ SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists_multi WHERE a = 0 OR
       2649 |   1572
 (1 row)
 
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists_multi WHERE a = b AND c = d');
+ estimated | actual 
+-----------+--------
+         1 |   5000
+(1 row)
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists_multi WHERE a != b AND c != d');
+ estimated | actual 
+-----------+--------
+      4950 |      0
+(1 row)
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists_multi WHERE a < b AND c > d');
+ estimated | actual 
+-----------+--------
+       556 |      0
+(1 row)
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists_multi WHERE a <= b AND c >= d');
+ estimated | actual 
+-----------+--------
+       556 |   5000
+(1 row)
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists_multi WHERE a = b OR c = d');
+ estimated | actual 
+-----------+--------
+        50 |   5000
+(1 row)
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists_multi WHERE a != b OR c != d');
+ estimated | actual 
+-----------+--------
+      5000 |      0
+(1 row)
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists_multi WHERE a < b OR c > d');
+ estimated | actual 
+-----------+--------
+      2778 |      0
+(1 row)
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists_multi WHERE a <= b OR c >= d');
+ estimated | actual 
+-----------+--------
+      2778 |   5000
+(1 row)
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists_multi WHERE a = a AND c = d');
+ estimated | actual 
+-----------+--------
+        25 |   5000
+(1 row)
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists_multi WHERE a != b AND c != c');
+ estimated | actual 
+-----------+--------
+      4950 |      0
+(1 row)
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists_multi WHERE a < a AND c > d');
+ estimated | actual 
+-----------+--------
+       556 |      0
+(1 row)
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists_multi WHERE a <= b AND d >= c');
+ estimated | actual 
+-----------+--------
+       556 |   5000
+(1 row)
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists_multi WHERE a = a OR c = d');
+ estimated | actual 
+-----------+--------
+        50 |   5000
+(1 row)
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists_multi WHERE a != b OR c != c');
+ estimated | actual 
+-----------+--------
+      5000 |      0
+(1 row)
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists_multi WHERE a < a OR c > d');
+ estimated | actual 
+-----------+--------
+      2778 |      0
+(1 row)
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists_multi WHERE a <= b OR d >= c');
+ estimated | actual 
+-----------+--------
+      2778 |   5000
+(1 row)
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists_multi WHERE a < b');
+ estimated | actual 
+-----------+--------
+      1667 |      0
+(1 row)
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists_multi WHERE a > b');
+ estimated | actual 
+-----------+--------
+      1667 |      0
+(1 row)
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists_multi WHERE a <= b');
+ estimated | actual 
+-----------+--------
+      1667 |   5000
+(1 row)
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists_multi WHERE a >= b');
+ estimated | actual 
+-----------+--------
+      1667 |   5000
+(1 row)
+
 -- create separate MCV statistics
 CREATE STATISTICS mcv_lists_multi_1 (mcv) ON a, b FROM mcv_lists_multi;
 CREATE STATISTICS mcv_lists_multi_2 (mcv) ON c, d FROM mcv_lists_multi;
@@ -2931,6 +4851,126 @@ SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists_multi WHERE a = 0 OR
       1571 |   1572
 (1 row)
 
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists_multi WHERE a = b AND c = d');
+ estimated | actual 
+-----------+--------
+         1 |   5000
+(1 row)
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists_multi WHERE a != b AND c != d');
+ estimated | actual 
+-----------+--------
+      4950 |      0
+(1 row)
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists_multi WHERE a < b AND c > d');
+ estimated | actual 
+-----------+--------
+       556 |      0
+(1 row)
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists_multi WHERE a <= b AND c >= d');
+ estimated | actual 
+-----------+--------
+       556 |   5000
+(1 row)
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists_multi WHERE a = b OR c = d');
+ estimated | actual 
+-----------+--------
+        50 |   5000
+(1 row)
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists_multi WHERE a != b OR c != d');
+ estimated | actual 
+-----------+--------
+      5000 |      0
+(1 row)
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists_multi WHERE a < b OR c > d');
+ estimated | actual 
+-----------+--------
+      2778 |      0
+(1 row)
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists_multi WHERE a <= b OR c >= d');
+ estimated | actual 
+-----------+--------
+      2778 |   5000
+(1 row)
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists_multi WHERE a = a AND c = d');
+ estimated | actual 
+-----------+--------
+        25 |   5000
+(1 row)
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists_multi WHERE a != b AND c != c');
+ estimated | actual 
+-----------+--------
+      4950 |      0
+(1 row)
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists_multi WHERE a < a AND c > d');
+ estimated | actual 
+-----------+--------
+       556 |      0
+(1 row)
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists_multi WHERE a <= b AND d >= c');
+ estimated | actual 
+-----------+--------
+       556 |   5000
+(1 row)
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists_multi WHERE a = a OR c = d');
+ estimated | actual 
+-----------+--------
+        50 |   5000
+(1 row)
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists_multi WHERE a != b OR c != c');
+ estimated | actual 
+-----------+--------
+      5000 |      0
+(1 row)
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists_multi WHERE a < a OR c > d');
+ estimated | actual 
+-----------+--------
+      2778 |      0
+(1 row)
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists_multi WHERE a <= b OR d >= c');
+ estimated | actual 
+-----------+--------
+      2778 |   5000
+(1 row)
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists_multi WHERE a < b');
+ estimated | actual 
+-----------+--------
+      1667 |      0
+(1 row)
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists_multi WHERE a > b');
+ estimated | actual 
+-----------+--------
+      1667 |      0
+(1 row)
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists_multi WHERE a <= b');
+ estimated | actual 
+-----------+--------
+      1667 |   5000
+(1 row)
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists_multi WHERE a >= b');
+ estimated | actual 
+-----------+--------
+      1667 |   5000
+(1 row)
+
 DROP TABLE mcv_lists_multi;
 -- statistics on integer expressions
 CREATE TABLE expr_stats (a int, b int, c int);
diff --git a/src/test/regress/sql/stats_ext.sql b/src/test/regress/sql/stats_ext.sql
index 6b954c9e500..1b4d57e0462 100644
--- a/src/test/regress/sql/stats_ext.sql
+++ b/src/test/regress/sql/stats_ext.sql
@@ -989,6 +989,30 @@ SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists WHERE a = 1 OR b = '
 
 SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists WHERE a = 1 OR b = ''1'' OR c = 1 OR d IS NOT NULL');
 
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists WHERE a = a');
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists WHERE a != a');
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists WHERE a <= a');
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists WHERE a < a');
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists WHERE a > a');
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists WHERE a >= a');
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists WHERE a = c');
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists WHERE a != c');
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists WHERE a > c');
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists WHERE a >= c');
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists WHERE a < c');
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists WHERE a <= c');
+
 SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists WHERE a IN (1, 2, 51, 52) AND b IN ( ''1'', ''2'')');
 
 SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists WHERE a IN (1, 2, 51, 52, NULL) AND b IN ( ''1'', ''2'', NULL)');
@@ -1042,6 +1066,30 @@ SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists WHERE a = 1 OR b = '
 
 SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists WHERE a = 1 OR b = ''1'' OR c = 1 OR d IS NOT NULL');
 
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists WHERE a = a');
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists WHERE a != a');
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists WHERE a <= a');
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists WHERE a < a');
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists WHERE a > a');
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists WHERE a >= a');
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists WHERE a = c');
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists WHERE a != c');
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists WHERE a > c');
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists WHERE a >= c');
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists WHERE a < c');
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists WHERE a <= c');
+
 SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists WHERE a IN (1, 2, 51, 52) AND b IN ( ''1'', ''2'')');
 
 SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists WHERE a IN (1, 2, 51, 52, NULL) AND b IN ( ''1'', ''2'', NULL)');
@@ -1241,6 +1289,221 @@ SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists WHERE a = 1 OR b = '
 
 SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists WHERE a IS NULL AND (b = ''x'' OR d = ''x'')');
 
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists WHERE b = d');
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists WHERE b = d AND a > a');
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists WHERE b = d AND a < a');
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists WHERE b = d AND a = a');
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists WHERE b = d AND NOT a = a');
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists WHERE b = d OR a > a');
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists WHERE b = d OR a < a');
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists WHERE b = d OR a = a');
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists WHERE b = d OR NOT a = a');
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists WHERE b != d');
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists WHERE b != d AND a > a');
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists WHERE b != d AND a < a');
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists WHERE b != d AND a = a');
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists WHERE b != d AND NOT a = a');
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists WHERE b != d OR a > a');
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists WHERE b != d OR a < a');
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists WHERE b != d OR a = a');
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists WHERE b != d OR NOT a = a');
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists WHERE b < d');
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists WHERE b < d AND a > a');
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists WHERE b < d AND a < a');
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists WHERE b < d AND a = a');
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists WHERE b < d AND NOT a = a');
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists WHERE b < d OR a > a');
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists WHERE b < d OR a < a');
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists WHERE b < d OR a = a');
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists WHERE b < d OR NOT a = a');
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists WHERE b <= d');
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists WHERE b <= d AND a > a');
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists WHERE b <= d AND a < a');
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists WHERE b <= d AND a = a');
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists WHERE b <= d AND NOT a = a');
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists WHERE b <= d OR a > a');
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists WHERE b <= d OR a < a');
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists WHERE b <= d OR a = a');
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists WHERE b <= d OR NOT a = a');
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists WHERE b > d');
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists WHERE b > d AND a > a');
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists WHERE b > d AND a < a');
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists WHERE b > d AND a = a');
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists WHERE b > d AND NOT a = a');
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists WHERE b > d OR a > a');
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists WHERE b > d OR a < a');
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists WHERE b > d OR a = a');
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists WHERE b > d OR NOT a = a');
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists WHERE b >= d');
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists WHERE b >= d AND a > a');
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists WHERE b >= d AND a < a');
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists WHERE b >= d AND a = a');
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists WHERE b >= d AND NOT a = a');
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists WHERE b >= d OR a > a');
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists WHERE b >= d OR a < a');
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists WHERE b >= d OR a = a');
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists WHERE b >= d OR NOT a = a');
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists WHERE b = d AND c > c');
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists WHERE b = d AND c < c');
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists WHERE b = d AND c = c');
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists WHERE b = d AND NOT c = c');
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists WHERE b = d OR c > c');
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists WHERE b = d OR c < c');
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists WHERE b = d OR c = c');
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists WHERE b = d OR NOT c = c');
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists WHERE b != d');
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists WHERE b != d AND c > c');
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists WHERE b != d AND c < c');
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists WHERE b != d AND c = c');
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists WHERE b != d AND NOT c = c');
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists WHERE b != d OR c > c');
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists WHERE b != d OR c < c');
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists WHERE b != d OR c = c');
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists WHERE b != d OR NOT c = c');
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists WHERE b < d');
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists WHERE b < d AND c > c');
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists WHERE b < d AND c < c');
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists WHERE b < d AND c = c');
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists WHERE b < d AND NOT c = c');
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists WHERE b < d OR c > c');
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists WHERE b < d OR c < c');
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists WHERE b < d OR c = c');
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists WHERE b < d OR NOT c = c');
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists WHERE b <= d');
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists WHERE b <= d AND c > c');
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists WHERE b <= d AND c < c');
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists WHERE b <= d AND c = c');
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists WHERE b <= d AND NOT c = c');
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists WHERE b <= d OR c > c');
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists WHERE b <= d OR c < c');
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists WHERE b <= d OR c = c');
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists WHERE b <= d OR NOT c = c');
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists WHERE b > d');
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists WHERE b > d AND c > c');
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists WHERE b > d AND c < c');
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists WHERE b > d AND c = c');
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists WHERE b > d AND NOT c = c');
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists WHERE b > d OR c > c');
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists WHERE b > d OR c < c');
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists WHERE b > d OR c = c');
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists WHERE b > d OR NOT c = c');
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists WHERE b >= d');
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists WHERE b >= d AND c > c');
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists WHERE b >= d AND c < c');
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists WHERE b >= d AND c = c');
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists WHERE b >= d AND NOT c = c');
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists WHERE b >= d OR c > c');
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists WHERE b >= d OR c < c');
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists WHERE b >= d OR c = c');
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists WHERE b >= d OR NOT c = c');
+
+
 -- create statistics
 CREATE STATISTICS mcv_lists_stats (mcv) ON a, b, d FROM mcv_lists;
 
@@ -1259,6 +1522,219 @@ SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists WHERE a = 1 OR b = '
 
 SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists WHERE a IS NULL AND (b = ''x'' OR d = ''x'')');
 
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists WHERE b = d');
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists WHERE b = d AND a > a');
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists WHERE b = d AND a < a');
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists WHERE b = d AND a = a');
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists WHERE b = d AND NOT a = a');
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists WHERE b = d OR a > a');
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists WHERE b = d OR a < a');
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists WHERE b = d OR a = a');
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists WHERE b = d OR NOT a = a');
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists WHERE b != d');
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists WHERE b != d AND a > a');
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists WHERE b != d AND a < a');
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists WHERE b != d AND a = a');
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists WHERE b != d AND NOT a = a');
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists WHERE b != d OR a > a');
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists WHERE b != d OR a < a');
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists WHERE b != d OR a = a');
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists WHERE b != d OR NOT a = a');
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists WHERE b < d');
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists WHERE b < d AND a > a');
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists WHERE b < d AND a < a');
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists WHERE b < d AND a = a');
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists WHERE b < d AND NOT a = a');
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists WHERE b < d OR a > a');
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists WHERE b < d OR a < a');
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists WHERE b < d OR a = a');
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists WHERE b < d OR NOT a = a');
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists WHERE b <= d');
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists WHERE b <= d AND a > a');
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists WHERE b <= d AND a < a');
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists WHERE b <= d AND a = a');
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists WHERE b <= d AND NOT a = a');
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists WHERE b <= d OR a > a');
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists WHERE b <= d OR a < a');
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists WHERE b <= d OR a = a');
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists WHERE b <= d OR NOT a = a');
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists WHERE b > d');
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists WHERE b > d AND a > a');
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists WHERE b > d AND a < a');
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists WHERE b > d AND a = a');
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists WHERE b > d AND NOT a = a');
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists WHERE b > d OR a > a');
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists WHERE b > d OR a < a');
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists WHERE b > d OR a = a');
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists WHERE b > d OR NOT a = a');
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists WHERE b >= d');
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists WHERE b >= d AND a > a');
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists WHERE b >= d AND a < a');
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists WHERE b >= d AND a = a');
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists WHERE b >= d AND NOT a = a');
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists WHERE b >= d OR a > a');
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists WHERE b >= d OR a < a');
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists WHERE b >= d OR a = a');
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists WHERE b >= d OR NOT a = a');
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists WHERE b = d AND c > c');
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists WHERE b = d AND c < c');
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists WHERE b = d AND c = c');
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists WHERE b = d AND NOT c = c');
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists WHERE b = d OR c > c');
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists WHERE b = d OR c < c');
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists WHERE b = d OR c = c');
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists WHERE b = d OR NOT c = c');
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists WHERE b != d');
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists WHERE b != d AND c > c');
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists WHERE b != d AND c < c');
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists WHERE b != d AND c = c');
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists WHERE b != d AND NOT c = c');
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists WHERE b != d OR c > c');
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists WHERE b != d OR c < c');
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists WHERE b != d OR c = c');
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists WHERE b != d OR NOT c = c');
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists WHERE b < d');
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists WHERE b < d AND c > c');
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists WHERE b < d AND c < c');
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists WHERE b < d AND c = c');
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists WHERE b < d AND NOT c = c');
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists WHERE b < d OR c > c');
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists WHERE b < d OR c < c');
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists WHERE b < d OR c = c');
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists WHERE b < d OR NOT c = c');
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists WHERE b <= d');
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists WHERE b <= d AND c > c');
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists WHERE b <= d AND c < c');
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists WHERE b <= d AND c = c');
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists WHERE b <= d AND NOT c = c');
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists WHERE b <= d OR c > c');
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists WHERE b <= d OR c < c');
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists WHERE b <= d OR c = c');
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists WHERE b <= d OR NOT c = c');
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists WHERE b > d');
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists WHERE b > d AND c > c');
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists WHERE b > d AND c < c');
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists WHERE b > d AND c = c');
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists WHERE b > d AND NOT c = c');
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists WHERE b > d OR c > c');
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists WHERE b > d OR c < c');
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists WHERE b > d OR c = c');
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists WHERE b > d OR NOT c = c');
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists WHERE b >= d');
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists WHERE b >= d AND c > c');
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists WHERE b >= d AND c < c');
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists WHERE b >= d AND c = c');
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists WHERE b >= d AND NOT c = c');
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists WHERE b >= d OR c > c');
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists WHERE b >= d OR c < c');
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists WHERE b >= d OR c = c');
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists WHERE b >= d OR NOT c = c');
+
 -- mcv with pass-by-ref fixlen types, e.g. uuid
 CREATE TABLE mcv_lists_uuid (
     a UUID,
@@ -1334,6 +1810,66 @@ SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists_bool WHERE NOT a AND
 
 SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists_bool WHERE NOT a AND b AND NOT c');
 
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists_bool WHERE NOT a = a');
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists_bool WHERE NOT a != a');
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists_bool WHERE NOT a < a');
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists_bool WHERE NOT a <= a');
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists_bool WHERE NOT a > a');
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists_bool WHERE NOT a >= a');
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists_bool WHERE NOT a = b');
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists_bool WHERE NOT a != b');
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists_bool WHERE NOT a < b');
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists_bool WHERE NOT a <= b');
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists_bool WHERE NOT a > b');
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists_bool WHERE NOT a >= b');
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists_bool WHERE NOT a = a AND b = b');
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists_bool WHERE NOT a != a AND b != b');
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists_bool WHERE NOT a < a AND b < b');
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists_bool WHERE NOT a <= a AND b <= b');
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists_bool WHERE NOT a > a AND b > b');
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists_bool WHERE NOT a >= a AND b >= b');
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists_bool WHERE NOT a = b AND b = c');
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists_bool WHERE NOT a != b AND b != c');
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists_bool WHERE NOT a < b AND b < c');
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists_bool WHERE NOT a <= b AND b <= c');
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists_bool WHERE NOT a > b AND b > c');
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists_bool WHERE NOT a >= b AND b >= c');
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists_bool WHERE NOT a = c AND b = b');
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists_bool WHERE NOT a != c AND b != b');
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists_bool WHERE NOT a < c AND b < b');
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists_bool WHERE NOT a <= a AND b <= c');
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists_bool WHERE NOT a > a AND b > c');
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists_bool WHERE NOT a >= a AND b >= c');
+
 CREATE STATISTICS mcv_lists_bool_stats (mcv) ON a, b, c
   FROM mcv_lists_bool;
 
@@ -1347,6 +1883,66 @@ SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists_bool WHERE NOT a AND
 
 SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists_bool WHERE NOT a AND b AND NOT c');
 
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists_bool WHERE NOT a = a');
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists_bool WHERE NOT a != a');
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists_bool WHERE NOT a < a');
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists_bool WHERE NOT a <= a');
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists_bool WHERE NOT a > a');
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists_bool WHERE NOT a >= a');
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists_bool WHERE NOT a = b');
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists_bool WHERE NOT a != b');
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists_bool WHERE NOT a < b');
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists_bool WHERE NOT a <= b');
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists_bool WHERE NOT a > b');
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists_bool WHERE NOT a >= b');
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists_bool WHERE NOT a = a AND b = b');
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists_bool WHERE NOT a != a AND b != b');
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists_bool WHERE NOT a < a AND b < b');
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists_bool WHERE NOT a <= a AND b <= b');
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists_bool WHERE NOT a > a AND b > b');
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists_bool WHERE NOT a >= a AND b >= b');
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists_bool WHERE NOT a = b AND b = c');
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists_bool WHERE NOT a != b AND b != c');
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists_bool WHERE NOT a < b AND b < c');
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists_bool WHERE NOT a <= b AND b <= c');
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists_bool WHERE NOT a > b AND b > c');
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists_bool WHERE NOT a >= b AND b >= c');
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists_bool WHERE NOT a = c AND b = b');
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists_bool WHERE NOT a != c AND b != b');
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists_bool WHERE NOT a < c AND b < b');
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists_bool WHERE NOT a <= a AND b <= c');
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists_bool WHERE NOT a > a AND b > c');
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists_bool WHERE NOT a >= a AND b >= c');
+
 -- mcv covering just a small fraction of data
 CREATE TABLE mcv_lists_partial (
     a INT,
@@ -1419,6 +2015,10 @@ SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists_partial WHERE (a = 0
 
 DROP TABLE mcv_lists_partial;
 
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists_bool WHERE NOT a = b');
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists_bool WHERE NOT a = b AND b = c');
+
 -- check the ability to use multiple MCV lists
 CREATE TABLE mcv_lists_multi (
 	a INTEGER,
@@ -1447,6 +2047,31 @@ SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists_multi WHERE a = 0 AN
 SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists_multi WHERE (a = 0 AND b = 0) OR (c = 0 AND d = 0)');
 SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists_multi WHERE a = 0 OR b = 0 OR c = 0 OR d = 0');
 
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists_multi WHERE a = b AND c = d');
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists_multi WHERE a != b AND c != d');
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists_multi WHERE a < b AND c > d');
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists_multi WHERE a <= b AND c >= d');
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists_multi WHERE a = b OR c = d');
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists_multi WHERE a != b OR c != d');
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists_multi WHERE a < b OR c > d');
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists_multi WHERE a <= b OR c >= d');
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists_multi WHERE a = a AND c = d');
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists_multi WHERE a != b AND c != c');
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists_multi WHERE a < a AND c > d');
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists_multi WHERE a <= b AND d >= c');
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists_multi WHERE a = a OR c = d');
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists_multi WHERE a != b OR c != c');
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists_multi WHERE a < a OR c > d');
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists_multi WHERE a <= b OR d >= c');
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists_multi WHERE a < b');
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists_multi WHERE a > b');
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists_multi WHERE a <= b');
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists_multi WHERE a >= b');
+
 -- create separate MCV statistics
 CREATE STATISTICS mcv_lists_multi_1 (mcv) ON a, b FROM mcv_lists_multi;
 CREATE STATISTICS mcv_lists_multi_2 (mcv) ON c, d FROM mcv_lists_multi;
@@ -1461,6 +2086,31 @@ SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists_multi WHERE a = 0 AN
 SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists_multi WHERE (a = 0 AND b = 0) OR (c = 0 AND d = 0)');
 SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists_multi WHERE a = 0 OR b = 0 OR c = 0 OR d = 0');
 
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists_multi WHERE a = b AND c = d');
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists_multi WHERE a != b AND c != d');
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists_multi WHERE a < b AND c > d');
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists_multi WHERE a <= b AND c >= d');
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists_multi WHERE a = b OR c = d');
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists_multi WHERE a != b OR c != d');
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists_multi WHERE a < b OR c > d');
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists_multi WHERE a <= b OR c >= d');
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists_multi WHERE a = a AND c = d');
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists_multi WHERE a != b AND c != c');
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists_multi WHERE a < a AND c > d');
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists_multi WHERE a <= b AND d >= c');
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists_multi WHERE a = a OR c = d');
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists_multi WHERE a != b OR c != c');
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists_multi WHERE a < a OR c > d');
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists_multi WHERE a <= b OR d >= c');
+
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists_multi WHERE a < b');
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists_multi WHERE a > b');
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists_multi WHERE a <= b');
+SELECT * FROM check_estimated_rows('SELECT * FROM mcv_lists_multi WHERE a >= b');
+
 DROP TABLE mcv_lists_multi;
 
 
-- 
2.34.3

